using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace WinApp27 {
  public partial class Form1 : Form  {
    public Form1()  {
      InitializeComponent();
      Test();
    }
    public void Test() {
      int i;
      string sConnDb = "test";
      string sMasTbl = "parent";
      string sNewConn = "server=localhost;uid=root;pwd=;database=information_schema";
      string sSql;
      MySqlConnection oNewConn = null;
      DataSet dsNew = null;
      BindingSource bsDetTbl = null;
      MySqlDataAdapter daDetTbl = null;
      try {
        int iQry = 1;
        oNewConn = new MySqlConnection(sNewConn);
        dsNew = new DataSet();
        bsDetTbl = new BindingSource();
        
        if( iQry == 0 ) 
          sSql = "SELECT table_name FROM information_schema.tables " +
                 "WHERE table_schema = '" + sConnDb + "' AND table_name <> '" +sMasTbl + "'";
        else
          // CONNECTOR/NET BUG: THIS CAUSES AN EXCEPTION WHEN DATAADAPTER.Fill() IS CALLED!
          sSql = String.Format( "SELECT u.table_name AS table_name " +          
                                "FROM table_constraints AS c " +
                                "INNER JOIN key_column_usage AS u " +
                                "USING( constraint_schema, constraint_name ) "+
                                "WHERE u.referenced_table_schema = '{0}' " +
                                "AND u.referenced_table_name = '{1}' " +
                                "AND c.table_schema = '{0}' " + 
                                "AND c.constraint_type = 'FOREIGN KEY'",
                                sConnDb, 
                                sMasTbl 
                              );
        i = dsNew.Tables.Count;
        cbDetailTable.DataSource = bsDetTbl;
        daDetTbl = new MySqlDataAdapter(sSql, oNewConn);

        // THROWS:"There is already an open DataReader associated with this Connection which must be closed first."
        daDetTbl.Fill( dsNew );  // , srcTable ); ???

        if( dsNew.Tables[i].Rows.Count > 0 ) {
          bsDetTbl.DataSource = dsNew;
          bsDetTbl.DataMember = dsNew.Tables[i].ToString();     // "Tables" + i.ToString();
          cbDetailTable.DisplayMember = dsNew.Tables[i].Columns[0].ColumnName;
          cbDetailTable.ValueMember = dsNew.Tables[i].Columns[0].ColumnName;
          cbDetailTable.Focus();
        }
      } catch (Exception ex) {
        MessageBox.Show(ex.Message);
      } finally {
        oNewConn.Close();
    }
  }
}

}

